//finds the unserviced town nearest to the location inputted
function find_nearby_town(location,serviced_towns) {
   AILog.Info("Finding unserviced town near " + location);

   //create a list of potential towns
	local towns = AITownList();

   //remove serviced towns
   towns.RemoveList(serviced_towns);

   //remove towns that are too small to make a profit
   towns.Valuate(AITown.GetPopulation);
   towns.KeepAboveValue(100);

   //keep the closest town to the inputted location on the list
   towns.Valuate(AITown.GetDistanceManhattanToTile, location);
   towns.KeepBottom(1);
   AILog.Info("Town found at " + AITown.GetLocation(towns.Begin()));
   return(towns.Begin());
}

//replaces old busses
function renew_buses(depot) {

	local new_veh = null;
	//create a list of all our vehicles
	local vehicles = AIVehicleList();
	
	//replace all old vecicles
	for(local current_veh = vehicles.Begin(); !vehicles.IsEnd(); current_veh = vehicles.Next()) {

	if(AIVehicle.GetAgeLeft(current_veh) < 1) {
		AILog.Info("A vehicle needs replacing!");

			AIOrder.AppendOrder(current_veh, depot, AIOrder.OF_STOP_IN_DEPOT);
			if(new_veh = AIVehicle.CloneVehicle(depot, current_veh, true)) {
				AILog.Info("Vehicle Cloned!");
			while(!AIVehicle.SellVehicle(current_veh)) {
	
			}
			AILog.Info("Vehicle Sold!");
			AIVehicle.StartStopVehicle(new_veh);
			while(!AIOrder.IsGotoDepotOrder(new_veh, AIOrder.ORDER_CURRENT)) {
				this.Sleep(5);
			}
			AIOrder.RemoveOrder(new_veh, AIOrder.ORDER_CURRENT);
		}
	}

	}
	
}
